/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : COLAS DE MENSAJES
FICHERO     : cliente.c
DESCRIPCION : El cliente le envia al servidor un fichero a traves de una
              cola de mensajes.

*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "ej1.h"

int main(int argc, char *argv[])
{
  FILE *fp;
  int qid;
  mensaje m;
  char buffer[TAM_BUFFER];
  int leidos;
  
  if (argc!=2)
  {
    printf("Forma de uso: cliente nom_fich\n");
    exit(1);
  }
  if ((fp=fopen(argv[1],"r"))==NULL)
  {
    printf("No se pudo abrir el fichero: %s\n",argv[1]);
    exit(2);
  }
  if ((qid=msgget(CLAVE_COLA,0))<0){
    printf("Error: msgget no pudo abrir la cola de clave %d\n",CLAVE_COLA);
    exit(3);
  }
  m.tipo=1;
  while (! feof(fp))
  {
     leidos=fread(buffer,sizeof(char),TAM_BUFFER,fp);
     memcpy(m.datos,buffer,leidos);    
     if (msgsnd(qid,(char *) &m, leidos,0)!=0)
     {
        printf("Ocurrio el error %d en msgsnd\n",errno);
        fclose(fp);
        exit(4);
     } 
  }
  m.tipo=2;
  if (msgsnd(qid,(char *) &m, 0,0)!=0)
  {
        printf("Ocurrio el error %d en msgsnd\n",errno);
        fclose(fp);
        exit(4);
  }
  fclose(fp);
  exit(0); 
}
