/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : COLAS DE MENSAJES
FICHERO     : servidor.c
DESCRIPCION : El servidor recibe el fichero de la cola de mensaje y
              la escribe en otro fichero.
              
*/
#include <stdlib.h>
#include <stdio.h>
#include "ej1.h"

int main(int argc,char *argv[])
{
  FILE *fp;
  int qid;
  mensaje m;
  int leidos;
  
  if (argc!=2)
  {
    printf("Forma de uso: servidor nom_fich\n");
    exit(1);
  }  
  if ((fp=fopen(argv[1],"w"))==NULL)
  {
    printf("No se pudo abrir el fichero: %s\n",argv[1]);
    exit(2);
  }
  if ((qid=msgget(CLAVE_COLA,PERMISOS_COLA|IPC_CREAT))<0)
  {
    printf("El servidor no pudo crear la cola de mensajes con clave %d\n",CLAVE_COLA);
    exit(3);    
  }
  while (1)
  {
    leidos=msgrcv(qid,&m,TAM_BUFFER,0,0);  
    switch (m.tipo){
      case 1:
        fwrite(m.datos,sizeof(char),leidos,fp);
        break;      
      case 2:
        fclose(fp);
        if (msgctl(qid,IPC_RMID,(struct msqid_ds *) NULL)<0)
        {
          printf("Error al borrar la cola de mensajes de clave %d\n",CLAVE_COLA);
          exit(4);
        }
        exit(0);
    }
  }
  return 0;
}
