/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : MEMORIA COMPARTIDA
FICHERO     : cline.c
DESCRIPCION : Este es un ejemplo de uso de memoria compartida. 
  El programa opera en conjunto con el programa pline. 
  Este programa permite modificar la longitud de la linea 
  y el caracter escribiendo en un segmento de memoria compartido.
*/
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "line.h"

main(int argc, char *argv[])
{
	int i, id, res;
	struct info *ctrl;

	if (argc!= 3) {
		fprintf(stderr, "uso: cline <char> <length>\n");
		exit(3);
	}
	id = shmget(KEY, 0, 0);
	if (id < 0) {
		perror("cline: fallo shmget");
		exit(1);
	}
	ctrl = (struct info *)shmat(id, 0, 0);
	if (ctrl <= (struct info *)(0)) {
		perror("cline: fallo shmat:");
		exit(2);
	}
             
	/*Copia los datos de la linea de comandos en el segmento de memoria compartida */
	ctrl->c		= argv[1][0];
	ctrl->length	= atoi(argv[2]);
	
	res = shmdt(ctrl);
        if (res < 0) {
         perror("cline: fallo shmdt");
                         exit(1);
                    } 

	exit(0);
}
