/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : MEMORIA COMPARTIDA
FICHERO     : pline.c
DESCRIPCION : Este es un ejemplo de uso de memoria compartida. 
  El programa imprime una linea de texto cada cuatro segundos. 
  La longitud de la linea, y el caracter impreso se controlan 
  mediante dos valores incluidos en una pequenya estructura de datos 
  en un segmento de memoria compartida. Cualquier otro programa puede 
  vincular dicho segmento y modificar los campos de la estructura de datos.
*/

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include "line.h"

main()
{
	int i, id, res;
	struct info *ctrl;

	id = shmget(KEY, SEGSIZE, IPC_CREAT | 0666);
	if (id < 0) {
		perror("pline: fallo shmget :");
		exit(1);
	}

	ctrl = (struct info *)shmat(id, 0, 0);
	if (ctrl <= (struct info *)(0)) {
		perror("pline: fallo shmat:");
		exit(2);
	}
	/*Inicia los parametros por defecto */
	ctrl->c		= 'a';
	ctrl->length	= 10;

	/*Este bucle imprime una linea cada 4 segundos */
	while (ctrl->length > 0) {
		for(i = 0; i < ctrl->length; i++)
			putchar(ctrl->c);
		putchar('\n');
		sleep(1);
	}
	
	
	res = shmdt(ctrl);
	if (res < 0)
	 {
	   perror("pline: fallo shmdt:");
               exit(2); 
	 }
	 
	if (shmctl(id,IPC_RMID,(struct shmid_ds *) NULL)<0) {
		perror("pline: shmctl failed:");
		exit(3);
	}
	
	  
        printf ("Final de pline, adios!!!"); 
	exit(0);
}
