/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SEMAFOROS IPC
FICHERO     : cline.c
DESCRIPCION : Este es un ejemplo de uso de memoria compartida y semaforos IPC.
  El programa opera en conjunto con el programa pline. 
  Este programa permite modificar la longitud de la linea 
  y el caracter escribiendo en un segmento de memoria compartido.
*/

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "line.h"

main(int argc, char *argv[])
{
	int i, shmemid, semid, res;
	struct info *ctrl;
	struct shmid_ds shmbuf;

	if (argc!= 3) {
		fprintf(stderr, "uso: cline <char> <length>\n");
		exit(3);
	}
	shmemid = shmget(KEYSHMEM, SEGSIZE, 0);
	if (shmemid < 0) {
		perror("cline: shmget faild:");
		exit(1);
	}
	ctrl = (struct info *)shmat(shmemid, 0, 0);
	if (ctrl <= (struct info *)(0)) {
		perror("cline: shmat failed:");
		exit(2);
	}

        semid = semget(KEYSEM,0,0);
	if (semid < 0) {
		perror("cline: semget failed:");
		exit(1);
	}

        /* Intenta entrar en la seccion critica */
        Lock (semid, 0);

	/*Copia los datos de la linea de comandos en el segmento de memoria compartida */
	ctrl->c		= argv[1][0];
	ctrl->length	= atoi(argv[2]);

        /* Sale de la seccion critica */
        Unlock (semid, 0);

        res = shmdt(ctrl);
        if (res < 0) {
            perror("cline: fallo shmdt");
            exit(1);
        }
	exit(0);
}
