/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SEMAFOROS IPC
FICHERO     : funcsem.h
DESCRIPCION :  Fichero en el que se implementan funciones de semaforos IPC:
   Lock
   Unlock
   InicializaElemento
   InicializaSemaforo
*/

#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "line.h"

void Lock (int sem, int n)
{
	struct sembuf sop;	// struct para una operacin
	sop.sem_num = n;	// la operacin se aplicar sobre el elemento n
	sop.sem_op = -1;	// operacin de decremento de una unidad
	sop.sem_flg = 0;	// Se bloquea hasta que el recurso est libre
	semop (sem, &sop, 1);	// Llamada a semop().
}

void Unlock (int sem, int n)
{
	struct sembuf sop;	// struct para una operacin
	sop.sem_num = n;	// se aplicar la operacin sobre el elemento n
	sop.sem_op = 1;		// operacin de incremento en una unidad
	sop.sem_flg = 0;		
	semop (sem, &sop, 1);	// Llamada a semop ()
}

int InicializaElemento (int sem, int n, int valor)
{
	union semun arg;	// union para los argumentos de la operacin
	if (valor < 0)
		return -1;
	arg.val = valor;	// El elemento n se inicializar a valor
	semctl (sem, n, SETVAL, arg);	// Llamada a semctl().
	return 0;
}


