/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SEMAFOROS IPC
FICHERO     : pline.c
DESCRIPCION :  Este es un ejemplo de uso de memoria compartida y semaforos IPC.
  El programa imprime una linea de texto cada cuatro segundos. 
  La longitud de la linea, y el caracter impreso se controlan 
  mediante dos valores incluidos en una pequenya estructura de datos 
  en un segmento de memoria compartida. Cualquier otro programa puede 
  vincular dicho segmento y modificar los campos de la estructura de datos.
*/

#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "line.h"

main()
{
	int i, shmemid, semid, local, res;
	struct info *ctrl;
	struct shmid_ds shmbuf;

	shmemid = shmget(KEYSHMEM, SEGSIZE, IPC_CREAT | 0666);
	if (shmemid < 0) {
		perror("pline: shmget failed:");
		exit(1);
	}

	ctrl = (struct info *)shmat(shmemid, 0, 0);
	if (ctrl <= (struct info *)(0)) {
		perror("pline: shmat failed:");
		exit(2);
	}

        /* crea el semaforo IPC de un elemento */
        semid = semget (KEYSEM, SEMSIZE, IPC_CREAT | 0666);
	if (semid < 0) {
		perror("pline: semget failed:");
		exit(1);
	}

        /* Inicializa a 1 el elemento 0 del semaforo IPC */
        if (InicializaElemento (semid, 0, 1) < 0) {
          perror("pline: InicializaElemento failed:");
          exit (5);
        }

        /* Intenta entrar en la seccion critica */
        Lock (semid, 0);

	/*Iniciailza los parametros por defecto */
	ctrl->c		= 'a';
	ctrl->length	= 10;
        local = ctrl->length;

        /* Sale de la seccion critica*/
        Unlock (semid, 0);

	/*Este bucle imprime una linea cada 4 segundos */
	while (local > 0) {
         /* Intenta entrar en la seccion critica */
         Lock (semid, 0);

         for(i = 0; i < ctrl->length; i++)
			putchar(ctrl->c);
		putchar('\n');

         /* Sale de la seccion critica */
         Unlock (semid, 0);

		sleep(4);

         Lock (semid, 0);
         local = ctrl->length;
         Unlock (semid, 0);
	}
	
	res = shmdt(ctrl);
        if (res < 0)
            {
             perror("pline: fallo shmdt:");
             exit(2);
            } 
	if (shmctl(shmemid,IPC_RMID,(struct shmid_ds *) NULL)<0) {
		perror("pline: shmctl failed:");
		exit(3);
	}
        if (semctl(semid,0,IPC_RMID)<0) {
		perror("pline: shmctl failed:");
		exit(3);
	}
        printf ("Final de pline, adios!!!");
	exit(0);
}
