/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SOCKETS TCP
FICHERO     : cliente.c
DESCRIPCION : Ejemplo de cliente orientado a conexion utilizando protocolos Internet. 
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "conexion.h"


int main (int argc, char * argv[])
{
  FILE *fp;
  struct sockaddr_in servidor;	/* La direccion del servidor se compone aqui */
  struct hostent *host_info;
  char datos[BUFFER_LECTURA];
  char *nombre_servidor;
  int sock,leidos;

  if (argc<2)
  {
    fprintf(stderr,"Forma de uso: cliente fich [dir_servidor]\n");
    exit(1); 
  }
  /* Obtenemos la direccion del servidor desde la linea de comandos */
  
  nombre_servidor=(argc>2) ? argv[2] : "localhost";
  
  /* Creamos el socket del cliente */
  
  sock = socket(AF_INET, SOCK_STREAM, 0); 
  if (sock<0)
  {
    fprintf(stderr,"Error creando el socket. \n");
    exit(2);
  }
  host_info = gethostbyname(nombre_servidor);
  if (host_info==NULL)
  {
    fprintf(stderr,"%s: nombre de host desconocido: %s\n",argv[0],nombre_servidor);
    exit(3);
  }
  /* Establecer la direccion de conexion del socket del servidor para 
     luego conectarnos 
   */
  servidor.sin_family=host_info->h_addrtype;
  memcpy((char *) &servidor.sin_addr,host_info->h_addr,host_info->h_length);
  servidor.sin_port=htons(PUERTO_SERVIDOR);
  
  if (connect(sock, (struct sockaddr *) &servidor, sizeof(servidor))<0)
  {
    fprintf(stderr,"Error conectando con el servidor\n");
    exit(4);
  }
  /* Ahora que ya estamos conectados con el servidor entramos en un bucle en 
  el que leemos desde el socket todas las lineas que nos envia el servidor y
  las almacenamos en un fichero
  */
  if ((fp=fopen(argv[1],"w"))==NULL)
  {
    fprintf(stderr,"Error al abrir el fichero %s\n",argv[1]);
    exit(5);
  }
  while ((leidos=read(sock,datos,BUFFER_LECTURA))>0)
  {
    fwrite(datos,sizeof(char),leidos,fp);    
  }
  fclose(fp);
  shutdown(sock,0);
  close(sock);
  return 0;
}
