/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SOCKETS UDP
FICHERO     : cliente.c
DESCRIPCION : 
   Ejemplo de cliente no orientado a conexion que utiliza los protocolos
   de la familia Internet.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "conexion.h"


int  main (int argc, char * argv[])
{
  FILE *fp;
  struct sockaddr_in servidor;	/* La direccion del servidor se compone aqui */
  struct sockaddr_in cliente;   /* La direccion del cliente */
  struct hostent *host_info;    /* Informacion de la maquina del servidor */
  char datos[BUFFER_LECTURA];
  char *nombre_servidor;
  int sock,leidos;
  int server_len;

  if (argc<2)
  {
    fprintf(stderr,"Forma de uso: cliente fich [dir_servidor]\n");
    exit(1); 
  }
  /* Obtenemos la direccion del servidor desde la linea de comandos */
  
  nombre_servidor=(argc>2) ? argv[2] : "localhost";
  
  /* Creamos el socket del cliente */
  
  sock = socket(AF_INET, SOCK_DGRAM, 0); 
  if (sock<0)
  {
    fprintf(stderr,"Error creando el socket. \n");
    exit(2);
  }
  /* Asociamos una direccion local. Cualquier numero de puerto valdra.
     Este paso no es esencial para el cliente. Si no lo hacemos el sistema
     elegira por nosotros un numero de puerto arbitrario.
  */
  cliente.sin_family = AF_INET;
  cliente.sin_addr.s_addr=htonl(INADDR_ANY);
  cliente.sin_port=0; /* el 0 significa que el sistema escoja cualquier puerto libre */
  if (bind(sock,(struct sockaddr *) &cliente, sizeof(cliente))<0)
  {
    fprintf(stderr,"Fallo el bind.\n");
    exit(3);
  }
  host_info = gethostbyname(nombre_servidor);
  if (host_info==NULL)
  {
    fprintf(stderr,"%s: nombre de host desconocido: %s\n",argv[0],nombre_servidor);
    exit(4);
  }
  /* Establecer la direccion de conexion del socket del servidor para 
     luego conectarnos 
   */
  servidor.sin_family=AF_INET;
  memcpy((char *) &servidor.sin_addr.s_addr,host_info->h_addr,host_info->h_length);
  servidor.sin_port=htons(PUERTO_SERVIDOR);
  
  /* Ahora que ya estamos conectados con el servidor entramos en un bucle en 
  el que leemos desde el socket todas las lineas que nos envia el servidor y
  las almacenamos en un fichero
  */
  if ((fp=fopen(argv[1],"r"))==NULL)
  {
    fprintf(stderr,"Error al abrir el fichero %s\n",argv[1]);
    exit(5);
  }
  while (! feof(fp))
  {
    leidos=fread(datos,sizeof(char),BUFFER_LECTURA,fp);
    server_len=sizeof(servidor);
    if (sendto(sock,datos,leidos,0,(struct sockaddr *) &servidor,server_len)!=leidos)
    {
      fprintf(stderr,"Error en el sendto.\n");
      exit(6);
    }
  }
  fclose(fp);
  shutdown(sock,1);
  close(sock);

  return 0;
}
