/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SOCKETS UDP
FICHERO     : servidor.c
DESCRIPCION :
   Ejemplo de servidor no orientado a conexion que utiliza los
   protocolos de la familia Internet, uso de recv() y send().
*/

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "conexion.h"


int  main(int argc,char *argv[])
{
  FILE *fp;
  int sock;
  struct sockaddr_in servidor;
  int leidos,escritos;
  char datos[BUFFER_LECTURA];
  
  if (argc<2){
    fprintf(stderr,"Forma de uso: servidor fichero\n");
    exit(1);
  }
  if ((fp=fopen(argv[1],"w"))==NULL)
  {
    fprintf(stderr,"No se pudo abrir el fichero %s\n",argv[1]);
    exit(2);
  }
  sock=socket(AF_INET,SOCK_DGRAM,0);
  if (sock<0)
  {
    fprintf(stderr,"No se pudo crear el socket.\n");
    exit(3);
  }
  servidor.sin_family=AF_INET;
  servidor.sin_addr.s_addr=htonl(INADDR_ANY);
  servidor.sin_port=htons(PUERTO_SERVIDOR);
  if (bind(sock,(struct sockaddr *) &servidor, sizeof(servidor))<0){
    fprintf(stderr,"Error vinculando el socket.\n");
    exit(4);  
  }
  do
  {
    leidos=recv(sock,datos,BUFFER_LECTURA,0);    
    if (leidos<0)
    {
      fprintf(stderr,"Error %d en el recvfrom.\n",errno);
      exit(5);
    }
    escritos=fwrite(datos,sizeof(char),leidos,fp);
    if (escritos!=leidos)
    {
      fprintf(stderr,"Error de escritura en el fichero.\n");
      exit(6);
    }
  }
  while (leidos==BUFFER_LECTURA);
  shutdown(sock,0);
  close(sock);
  fclose(fp);
  return 0;
}
