/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SOCKETS UNIX
FICHERO     : cliente.c
DESCRIPCION :
   Ejemplo de cliente orientado a conexion que utiliza la familia de
   protocolos Unix.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "conexion.h"


int main (int argc, char * argv[])
{
  FILE *fp;
  struct sockaddr_un servidor;	/* La direccion del servidor se compone aqui */

  char datos[BUFFER_LECTURA];
  int sock,leidos;
  int len_servidor,cliente_len;

  if (argc!=2)
  {
    fprintf(stderr,"Forma de uso: cliente fich \n");
    exit(1); 
  }
  
  /* Establecer la direccion de conexion del socket del servidor para 
     luego conectarnos 
   */

  bzero((char *) &servidor,sizeof(servidor));
  servidor.sun_family=AF_UNIX;
  strcpy(servidor.sun_path,SOCKET_UNIX);
  len_servidor=strlen(servidor.sun_path)+sizeof(servidor.sun_family);
  
  
  /* Creamos el socket del cliente */
  
  sock = socket(AF_UNIX, SOCK_STREAM, 0); 
  if (sock<0)
  {
    fprintf(stderr,"Error creando el socket. \n");
    exit(2);
  }
  
  /* Nos conectamos al servidor */
  
  if (connect(sock, (struct sockaddr *) &servidor, len_servidor)<0)
  {
    fprintf(stderr,"Error conectando con el servidor\n");
    exit(3);
  }
  /* Ahora que ya estamos conectados con el servidor entramos en un bucle en 
  el que leemos desde el socket todas las lineas que nos envia el servidor y
  las almacenamos en un fichero
  */
  if ((fp=fopen(argv[1],"w"))==NULL)
  {
    fprintf(stderr,"Error al abrir el fichero %s\n",argv[1]);
    exit(4);
  }
  while ((leidos=read(sock,datos,BUFFER_LECTURA))>0)
  {
    fwrite(datos,sizeof(char),leidos,fp);    
  }
  fclose(fp);
  shutdown(sock,0);
  close(sock);
  return 0;
}
