/*
ESCUELA POLITECNICA SUPERIOR DE INGENIEROS DE GIJON

INGENIERIA INFORMATICA

SISTEMAS DE COMPUTACION

MATERIAL DE LA ASIGNATURA
-------------------------

PARTE       : SISTEMAS DISTRIBUIDOS
BLOQUE      : MECANISMOS IPC
MECANISMO   : SOCKETS UNIX
FICHERO     : servidor.c
DESCRIPCION :
   Ejemplo de servidor orientado a conexion que utiliza la familia
   de protocolos Unix
*/

#include <stdlib.h>
#include <stdio.h>
#include "conexion.h"


int main(int argc,char *argv[])
{
  FILE *fp;
  int sock,fd;
  struct sockaddr_un servidor,cliente;
  int servidor_len,cliente_len,leidos;
  char datos[BUFFER_LECTURA];
  
  if (argc<2){
    fprintf(stderr,"Forma de uso: servidor fichero\n");
    exit(1);
  }
  if ((fp=fopen(argv[1],"r"))==NULL)
  {
    fprintf(stderr,"No se pudo abrir el fichero %s\n",argv[1]);
    exit(2);
  }
  sock=socket(AF_UNIX,SOCK_STREAM,0);
  if (sock<0)
  {
    fprintf(stderr,"No se pudo crear el socket.\n");
    exit(3);
  }
  bzero((char *) &servidor,sizeof(servidor));
  servidor.sun_family=AF_UNIX;
  strcpy(servidor.sun_path,SOCKET_UNIX);
  servidor_len=strlen(servidor.sun_path)+sizeof(servidor.sun_family);
  if (bind(sock,(struct sockaddr *) &servidor, servidor_len)<0){
    fprintf(stderr,"Error vinculando el socket.\n");
    exit(4);  
  }
  listen(sock,5);
  cliente_len=sizeof(cliente);
  fd=accept(sock,(struct sockaddr *) &cliente,&cliente_len);
  while (! feof(fp))
  {
    leidos=fread(datos,sizeof(char),BUFFER_LECTURA,fp);
    write(fd,datos,(size_t) leidos);
  }
  shutdown(fd,1);
  close(fd);
  close(sock);
  fclose(fp);
  return 0;
}
